package matrix;

public class SubMatrixInitializer<T> implements MatrixInitializer<T> {
    private final Matrix<T> originMatrix;
    private final int x0;
    private final int y0;

    public SubMatrixInitializer(Matrix<T> originMatrix,int x0, int y0){
        this.originMatrix=originMatrix;
        this.x0=x0;
        this.y0=y0;
    }

    @Override
    public T initialValueAt(Coordinate coordinate){
        int x= coordinate.x()+x0;
        int y = coordinate.y()+y0;
        return originMatrix.get(x,y);
    }

}
