package model.automata;

import model.CellularAutomaton;

import java.util.Random;

public class GameOfLifeAutomaton implements CellularAutomaton<GameOfLifeState> {
    public int columns;
    public int rows;
    public GameOfLifeAutomaton(int numberOfColumns, int numberOfRows) {
        this.columns=numberOfColumns;
        this.rows= numberOfRows;
    }

    @Override
    public int numberOfColumns() {
        return columns;
    }

    @Override
    public int numberOfRows() {
        return rows;
    }

    @Override
    public GameOfLifeState defaultState() {
        return GameOfLifeState.DEAD;
    }

    @Override
    public GameOfLifeState randomState(Random generator) {
        return generator.nextBoolean()?GameOfLifeState.ALIVE: GameOfLifeState.DEAD;
    }
}
