package model.automata;

import javafx.scene.paint.Color;
import model.State;

import java.util.List;

/**
 * {@link GameOfLifeState} instances represent the possible states of a {@link GameOfLifeState}.
 */
public enum GameOfLifeState implements State<GameOfLifeState> {
    ALIVE, DEAD;


    @Override
    public Color getColor() {
       return this == ALIVE?
        Color.RED:Color.WHITE;
    }

    @Override
    public GameOfLifeState next() {
        return this==ALIVE?
        DEAD:ALIVE;
    }

    @Override
    public GameOfLifeState update(List<GameOfLifeState> neighbours) {
        long aliveNeighbors =neighbours.stream().filter(state -> state ==ALIVE).count();
        if (this ==ALIVE){
            return (aliveNeighbors ==2 || aliveNeighbors ==3)? ALIVE :DEAD;
        }else{
            return (aliveNeighbors==3)? ALIVE:DEAD;
        }
        }

}
